<template>
  <div class="_container">
    <rui-breadcrumbs :chunks="breadcrumbsChunks" />

    <header class="-mbl">
      <div class="-flex -gap -mtm">
        <rui-badge v-if="resource.generic" :caption="$t('activerecord.attributes.resource.generic')" />
        <h1 v-if="showTitle" class="-mv0">{{ resource.name }}</h1>
        <em class="-flex--grow -align-self-end -pbt">{{ resource.latinName }}</em>

        <rui-button @click="$emitBus('edit-resource', resource)">{{ $t('generic.edit') }}</rui-button>
      </div>

      <div class="-text--small -mbd">{{ resource.commonNames.join(', ') }}</div>
    </header>

    <div class="-grid-1-2 -gap">
      <div>
        <section class="-mbl">
          <dl>
            <dt>{{ $t('activerecord.attributes.resource.diameter') }}</dt>
            <dd>{{ resource.diameter ? prettyLength(resource.diameter) : '-' }}</dd>
          </dl>

          <dl>
            <dt>{{ $t('activerecord.attributes.resource.crop_rotation_group') }}</dt>
            <dd>{{ resource.cropRotationGroup ? $t(`activerecord.attributes.resource/crop_rotation_group.${resource.cropRotationGroup}`) : '-' }}</dd>
          </dl>
        </section>

        <section v-if="resource.generic" class="-mbl">
          <template v-if="children.length > 0">
            <h2>{{ $t('js.resources.description_area.children') }}</h2>
            <div v-for="child in children" :key="child.id">
              <template v-if="showLinks">
                <router-link :to="{name: 'library', params: {resourceId: child.id}}">{{ child.name }}</router-link>
              </template>
              <template v-else>{{ child.name }}</template>
            </div>
          </template>
        </section>

        <section class="-mbl">
          <h2>{{ $t('activerecord.attributes.resource.sources') }}</h2>
          <rui-empty v-if="resource.sources.length === 0" :content="$t('js.resources.description_area.no_sources')" inline />

          <div v-for="(source, index) in resource.sources" :key="index">
            <a :href="source" rel="noopener noreferrer">{{ hostName(source) }}</a>
          </div>
        </section>
      </div>

      <div>
        <section class="-mbl">
          <gp-markdown-renderer v-if="resource.description" :content="resource.description" />
          <rui-empty v-else icon="warning" :content="$t('js.resources.description_area.description_missing')" inline />
        </section>

        <section class="-mbl">
          <h2>{{ $t('js.resources.description_area.sow_harvest') }}</h2>
          <gp-months-flags :flags="monthFlags" />
        </section>

        <section class="-mbl">
          <div class="-flex -gap -mtm -mbd">
            <h2 class="-mv0">
              <template v-if="resource.resourceInteractionsGroupId">{{ $t('js.resources.description_area.interactions_for', {group: resource.resourceInteractionsGroup.name}) }}</template>
              <template v-else>{{ $t('js.resources.description_area.interactions') }}</template>
            </h2>
            <rui-help-button>
              <gpa-resource-interactions-help-table />
            </rui-help-button>
          </div>

          <gpa-resource-interactions-list :resource-interactions-group="resource.resourceInteractionsGroup" />
        </section>

        <section class="-mbl">
          <h2>{{ $t('activerecord.attributes.resource.tag_list') }}</h2>
          <div>
            <rui-empty v-if="resource.tagList.length === 0" :content="$t('js.resources.description_area.no_tags')" inline />
            <rui-tags :tags="resource.tagList" />
          </div>
        </section>

        <section class="-mbl">
          <header class="-flex -gap -mtm -mbd">
            <h2 class="-mv0">{{ $t('js.resources.description_area.user_notes') }}</h2>
            <rui-button icon="plus"
                        variant="creative"
                        :title="$t('js.resources.description_area.new_note')"
                        @click="showResourceNoteForm" />
          </header>
          <gpa-resource-notes :resource="resource" />
        </section>
      </div>
    </div>
  </div>
</template>

<script>
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiBreadcrumbs from '@experiments-labs/rise_ui/src/components/DataDisplay/Breadcrumbs/Breadcrumbs.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiTags from '@experiments-labs/rise_ui/src/components/DataDisplay/Tag/Tags.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'

import prettyLength from '../../../../../helpers/pretty_length'
import Resource from '../../../../classes/models/Resource'
import GpMarkdownRenderer from '../../../../common/DataDisplay/MarkdownRenderer/MarkdownRenderer.vue'
import GpaResourceNotes from '../ResourceNotes/ResourceNotes.vue'
import GpaResourceInteractionsList from '../ResourceInteractions/_List.vue'
import GpMonthsFlags from '../../../../common/DataDisplay/MonthsFlags/MonthsFlags.vue'
import GpaResourceInteractionsHelpTable from '../ResourceInteractions/_HelpTable.vue'

export default {
  name: 'GpaResource',
  components: {
    RuiTags,
    RuiHelpButton,
    RuiEmpty,
    RuiButton,
    RuiBadge,
    RuiBreadcrumbs,
    GpaResourceInteractionsHelpTable,
    GpaResourceInteractionsList,
    GpaResourceNotes,
    GpMonthsFlags,
    GpMarkdownRenderer,
  },
  props: {
    resource: { required: true, type: Resource },
    showTitle: { required: false, type: Boolean, default: true },
    showLinks: { required: false, type: Boolean, default: false },
  },
  computed: {
    genus () { return this.$store.getters.genus(this.$props.resource.genusId) },
    children () { return this.$props.resource.children },
    family () { return this.genus.family },
    breadcrumbsChunks () {
      const chunks = [
        { name: this.$t(`activerecord.attributes.family/kingdom.${this.family.kingdom}`) },
        { name: this.family.name, to: { name: 'libraryByFamily', params: { familyId: this.resource.genus.familyId, resourceId: this.resource.id } } },
        { name: this.genus.name, to: { name: 'libraryByGenus', params: { genusId: this.resource.genusId, resourceId: this.resource.id } } },
      ]

      if (this.resource.parentId) chunks.push({ name: this.resource.parent.name, to: { name: 'library', params: { resourceId: this.resource.parentId } } })

      chunks.push({ name: this.resource.name })

      return chunks
    },
    monthFlags () {
      const flags = {}
      flags[this.$t('js.resources.description_area.sheltered_sowing_months')] = this.$props.resource.shelteredSowingMonths
      flags[this.$t('js.resources.description_area.soil_sowing_months')] = this.$props.resource.soilSowingMonths
      flags[this.$t('js.resources.description_area.harvesting_months')] = this.$props.resource.harvestingMonths

      return flags
    },
  },
  methods: {
    showResourceNoteForm () { this.$emitBus('show-resource-note-form', { resourceId: this.$props.resource.id }) },
    hostName (url) {
      const uri = new URL(url)
      return uri.hostname
    },
    prettyLength,
  },
}
</script>
